PAGE ,132
TITLE FileName - File Description
;
;  FileName - File Description
;
;  This Program is assembled and linked into a Terminate-and-Stay-Resident
;  (TSR) .COM format executable.
;
;
;  Written By: Myke Predko
;
;
;  Version x.xx
;
;  Started: xx.xx.xx
;  Updated: xx.xx.xx
;
;
;  Conventions:
;  lower case - assembler mnemonics, macro names
;  Mixed Case - Variable Names, Program Labels, And Structures
;  UPPER CASE - CONSTANTS AND ASSEMBLER KEYWORDS
;
;  Chapters: (TSR Format)
;  Chapter  1 - Header
;  Chapter  2 - Start (Jump to Init)
;  Chapter  3 - Structures
;  Chapter  4 - Macros
;  Chapter  5 - Constants
;  Chapter  6 - Variables
;  Chapter  7 - TSR Interrupt Handlers
;  Chapter  8 - TSR Subroutines
;  Chapter 10 - Mainline Code (Setup Program and go TSR)
;  Chapter 11 - Messages

PAGE +
 .model tiny
 .stack
 .code
ProgSeg SEGMENT PARA PUBLIC 'CODE'
        ASSUME  CS:ProgSeg, DS:ProgSeg, ES:ProgSeg, SS:ProgSeg
        ORG     100H
Start:  jmp     Mainline        ;  Jump to the Program Initialize
        nop                     ;  Put Variables on Word Boundary

PAGE +
subtitle Program Structures
;
PtrFmt  STRUC                   ;  Format of a Pointer to Memory
PtrOff  dw      ?               ;  Offset to the Pointer
PtrSeg  dw      ?               ;  Segment of the Pointer
PtrFmt  ENDS

PAGE +
subtitle Program Macros
;

PAGE +
subtitle Program Constants
;
DOSINT  = 21h                   ;  DOS Interrupt Vector
DOSPrt  = 09h                   ;  Print String Operation
DOSTSR  = 31h                   ;  DOS Terminate and Stay Resident

PAGE +
subtitle Program Variables
;

PAGE +
subtitle Interrupt Handlers
;

PAGE +
subtitle TSR Subroutines
;

PAGE +
subtitle Mainline - Setup Program and go TSR
Mainline PROC   NEAR
;

;  Everything Done - Now Terminate and Stay Resident
        mov     ah, DOSPrt      ;  Print Message
        lea     dx, TSRMsg
        int     DOSINT
        lea     ax, Mainline    ;  Get Code Size needed in Paragraphs
        add     ax, 15          ;  Goto Next Highest Paragraph
        mov     cx, 4
        shr     ax, cl
        mov     dx, ax
        mov     ah, DOSTSR
        mov     al, 0
        int     DOSINT

PAGE +
subtitle Initialization Messages
TSRMsg  db      0Dh, 0Ah, 'TSR Template - Version x.xx'
        db      0Dh, 0Ah, 0Dh, 0Ah, 'Written by Myke Predko - xx.xx.xx'
        db      0Dh, 0Ah, '$'

Mainline ENDP
ProgSeg ENDS
        END     Start           ;  End of Program