//  LIFE.C - Play the "Game of Life" on a PC
//
//  This Program is Designed to be a demonstration of how to write
//   "C" Programs for MS-DOS with Console Interfacing.
//
//  Myke Predko
//
//  Started: 98.10.14
//  Updated: xx.xx.xx
//


//  Include Files
#include <dos.h>                //  For i86 Interrupts
#include <stdio.h>
#include <string.h>
#include <asmprocs.h>           //  My Assembly Language Routines
#include "global.var"


//  Defines (in "global.var")
#define ver "0.10A"             // Define the Current Code Version


//  Global Variables (in "global.var")


//  External Routines


//  Subroutines
ClearScrn()                     //  Clear the Screen Variable between
{                               //   Runs

int  i, j;


  for ( i = 0; i < 25; i++ )
    for ( j = 0; j < 60; j++ )
      Screen[( i * 80 ) + j ].character = '\0';

}  //  End ClearScrn


int Cnt( i, j )                 //  Return the Character at the Screen
{                               //   Address

int  k;


  if ( i < 0 )
    i = 24;
  else
    if ( i > 24 )
      i = 0;
  if ( j < 0 )
    j = 59;
  else
    if ( j > 59 )
      j = 0;

  k = Screen[( i * 80 ) + j ].character;

  return k;                     //  Return What was Read

}  //  End Cnt

Play()                          //  Read Screen to update "NewScreen"
{

int  i, j, k;


  for ( i = 0; i < 25; i++ )
    for ( j = 0; j < 60; j++ ) {
      k = Cnt( i-1, j ) + Cnt( i-1, j-1 ) + Cnt( i, j-1 ) +
                    Cnt( i+1, j-1 ) + Cnt( i+1, j ) + Cnt( i+1, j+1 )
                                   + Cnt( i, j+1 ) + Cnt( i-1, j+1 );
      if ( Screen[( i * 80 ) + j ].character == '\0' )
        if ( k == 6 )           //  Put in a New Character
          NewScreen[( i * 60 ) + j ].character = 0x002;
        else
          NewScreen[( i * 60 ) + j ].character = '\0';
      else                      //  Does it Stay Alive?
        if (( k < 4 ) || ( k > 6 ))
          NewScreen[( i * 60 ) + j ].character = '\0';
        else
          NewScreen[( i * 60 ) + j ].character = 0x002;
    }  //  endfor

  for ( i = 0; i < 25; i++ )    //  Update the PC's Display
    for ( j = 0; j < 60; j++ )
      Screen[( i * 80 ) + j ].character =
                                 NewScreen[( i * 60 ) + j ].character;

}  // End Play


InitMouse()                     //  Initialize The Cursor
{

union REGS regs;


  regs.x.ax = MOUSERST;         //  Reset the Mouse
  int86( MOUSEINT, &regs, &regs );

  regs.x.ax = MOUSECSR;         //  Show the Mouse
  int86( MOUSEINT, &regs, &regs );


}  //  End InitCursor


OffMouse()                      //  Turn off the Cursor
{

union REGS regs;


  regs.x.ax = MOUSEHID;         //  Hide the Mouse Cursor
  int86( MOUSEINT, &regs, &regs );

}  //  End OffMouse


PutSpeed( int Speed )           //  Set the
{


  ExecSpeed = Speed;            //  Save the Speed

  Screen[( 6 * 80 ) + 69 ].character = Speed + '0';

}  //  End PutSpeed


PutDelay( int hour, int minute, int second )
{                               //  Put the Length of Time Running

  Screen[( 14 * 80 ) + 71 ].character = ( hour / 10 ) + '0';
  Screen[( 14 * 80 ) + 72 ].character =
                                ( hour - (( hour / 10 ) * 10 )) + '0';

  Screen[( 14 * 80 ) + 74 ].character = ( minute / 10 ) + '0';
  Screen[( 14 * 80 ) + 75 ].character =
                            ( minute - (( minute / 10 ) * 10 )) + '0';

  Screen[( 14 * 80 ) + 77 ].character = ( second / 10 ) + '0';
  Screen[( 14 * 80 ) + 78 ].character =
                            ( second - (( second / 10 ) * 10 )) + '0';

}  //  End PutDelay


PutIterations( long Iterate )
{

int  i;


  if ( Iterate > 999999 )       //  Can Number be Put Down
    for ( i = 0; i < 6; i++ )   //  No, Blank Out
      Screen[( 13 * 80 ) + 73 + i ].character = 'x';
  else                          //  Can Display Number
    if ( Iterate < 100000 ) {   //  Hundreds of Thousands to Write?
      Screen[( 13 * 80 ) + 73 ].character = ' ';
      if ( Iterate < 10000 ) {  //  Tens of Thousands to Write?
        Screen[( 13 * 80 ) + 74 ].character = ' ';
        if ( Iterate < 1000 ) { //  Thousands to Write?
          Screen[( 13 * 80 ) + 75 ].character = ' ';
          if ( Iterate < 100 ) {  //  Hundreds to Write?
            Screen[( 13 * 80 ) + 76 ].character = ' ';
            if ( Iterate < 10 ) {  //  Just Ones to Write?
              Screen[( 13 * 80 ) + 77 ].character = ' ';
              Screen[( 13 * 80 ) + 78 ].character = Iterate + '0';
            } else {            //  Tens to Write
              Screen[( 13 * 80 ) + 77 ].character =
                                               ( Iterate / 10 ) + '0';
              Iterate = Iterate - (( Iterate / 10 ) * 10 );
              Screen[( 13 * 80 ) + 78 ].character = Iterate + '0';
            }
          } else {              //  Hundreds to Write
            Screen[( 13 * 80 ) + 76 ].character =
                                              ( Iterate / 100 ) + '0';
            Iterate = Iterate - (( Iterate / 100 ) * 100 );
            Screen[( 13 * 80 ) + 77 ].character =
                                               ( Iterate / 10 ) + '0';
            Iterate = Iterate - (( Iterate / 10 ) * 10 );
            Screen[( 13 * 80 ) + 78 ].character = Iterate + '0';
          }  /*  endif  */
        } else {                //  Thousands to Write
          Screen[( 13 * 80 ) + 75 ].character =
                                             ( Iterate / 1000 ) + '0';
          Iterate = Iterate - (( Iterate / 1000 ) * 1000 );
          Screen[( 13 * 80 ) + 76 ].character =
                                              ( Iterate / 100 ) + '0';
          Iterate = Iterate - (( Iterate / 100 ) * 100 );
          Screen[( 13 * 80 ) + 77 ].character =
                                               ( Iterate / 10 ) + '0';
          Iterate = Iterate - (( Iterate / 10 ) * 10 );
          Screen[( 13 * 80 ) + 78 ].character = Iterate + '0';
        }
      } else {                  //  Tens of Thousands to Write
        Screen[( 13 * 80 ) + 74 ].character =
                                            ( Iterate / 10000 ) + '0';
        Iterate = Iterate - (( Iterate / 10000 ) * 10000 );
        Screen[( 13 * 80 ) + 75 ].character =
                                             ( Iterate / 1000 ) + '0';
        Iterate = Iterate - (( Iterate / 1000 ) * 1000 );
        Screen[( 13 * 80 ) + 76 ].character = ( Iterate / 100 ) + '0';
        Iterate = Iterate - (( Iterate / 100 ) * 100 );
        Screen[( 13 * 80 ) + 77 ].character = ( Iterate / 10 ) + '0';
        Iterate = Iterate - (( Iterate / 10 ) * 10 );
        Screen[( 13 * 80 ) + 78 ].character = Iterate + '0';
      }
    } else {                    //  100K+ to Write
      Screen[( 13 * 80 ) + 73 ].character =
                                           ( Iterate / 100000 ) + '0';
      Iterate = Iterate - (( Iterate / 100000 ) * 100000 );
      Screen[( 13 * 80 ) + 74 ].character = ( Iterate / 10000 ) + '0';
      Iterate = Iterate - (( Iterate / 10000 ) * 10000 );
      Screen[( 13 * 80 ) + 75 ].character = ( Iterate / 1000 ) + '0';
      Iterate = Iterate - (( Iterate / 1000 ) * 1000 );
      Screen[( 13 * 80 ) + 76 ].character = ( Iterate / 100 ) + '0';
      Iterate = Iterate - (( Iterate / 100 ) * 100 );
      Screen[( 13 * 80 ) + 77 ].character = ( Iterate / 10 ) + '0';
      Iterate = Iterate - (( Iterate / 10 ) * 10 );
      Screen[( 13 * 80 ) + 78 ].character = Iterate + '0';
    }  /*  endif  */

}  //  End PutIterations


Init()                          //  Change the Display And Setup
{

union REGS regs;

int  i, j;

char far * Line1 = "    Game of LIFE";
char far * Line2 = "o";
char far * Line3 = "top";
char far * Line4 = "nd";
char far * Line5 = "Speed:";
char far * Line6 = "  Select Initial";
char far * Line7 = "  Locations with";
char far * Line8 = "  Mouse.";
char far * Line9 = "  Iteration:";
char far * Line0 = "  Elapsed:";
char far * LineA = "xx:xx:xx";
char far * LineB = "lear";


  ( long ) Screen = ( long ) ( 0x0B8000000L + ( VIDPAGE * 0x01000 ));

  for ( i = 0; i < 25; i++ )    //  Clear the Display
    {
      for ( j = 0; j < 60; j++ )
        {
          Screen[( i * 80 ) + j ].colour = RedBlack;
          Screen[( i * 80 ) + j ].character = '\0';
        }  /*  endfor  */
      for ( ; j < 80; j++ )
        {
          Screen[( i * 80 ) + j ].colour = WhiteGreen;
          Screen[( i * 80 ) + j ].character = ' ';
        }  /*  endfor  */
    }  /*  endfor  */

  for ( i = 0; i < strlen( Line1 ); i++ )
    {
      Screen[ 60 + i ].colour = YellowGreen;
      Screen[ 60 + i ].character = Line1[ i ];
    }  /*  endfor  */

  Screen[( 2 * 80 ) + 62 ].colour = YellowGreen;
  Screen[( 2 * 80 ) + 62 ].character = 'G';
  for ( i = 0; i < strlen( Line2 ); i++ )
    Screen[( 2 * 80 ) + 63 + i ].character = Line2[ i ];

  Screen[( 3 * 80 ) + 62 ].colour = YellowGreen;
  Screen[( 3 * 80 ) + 62 ].character = 'S';
  for ( i = 0; i < strlen( Line3 ); i++ )
    Screen[( 3 * 80 ) + 63 + i ].character = Line3[ i ];

  Screen[( 3 * 80 ) + 72 ].colour = YellowGreen;
  Screen[( 3 * 80 ) + 72 ].character = 'C';
  for ( i = 0; i < strlen( LineB ); i++ )
    Screen[( 3 * 80 ) + 73 + i ].character = LineB[ i ];

  Screen[( 4 * 80 ) + 62 ].colour = YellowGreen;
  Screen[( 4 * 80 ) + 62 ].character = 'E';
  for ( i = 0; i < strlen( Line4 ); i++ )
    Screen[( 4 * 80 ) + 63 + i ].character = Line4[ i ];

  for ( i = 0; i < strlen( Line5 ); i++ )
    Screen[( 6 * 80 ) + 62 + i ].character = Line5[ i ];
  Screen[( 6 * 80 ) + 69 ].colour = YellowGreen;
  PutSpeed( 1 );                //  Set the Speed to be Used

  for ( i = 0; i < strlen( Line6 ); i++ )
    Screen[( 8 * 80 ) + 60 + i ].character = Line6[ i ];
  for ( i = 0; i < strlen( Line7 ); i++ )
    Screen[( 9 * 80 ) + 60 + i ].character = Line7[ i ];
  for ( i = 0; i < strlen( Line8 ); i++ )
    Screen[( 10 * 80 ) + 60 + i ].character = Line8[ i ];

  for ( i = 0; i < strlen( Line9 ); i++ )
    Screen[( 13 * 80 ) + 60 + i ].character = Line9[ i ];
  PutIterations( 0L );          //  Put Number of Interations

  for ( i = 0; i < strlen( Line0 ); i++ )
    Screen[( 14 * 80 ) + 60 + i ].character = Line0[ i ];
  for ( i = 0; i < 8; i++ )
    Screen[( 14 * 80 ) + 71 + i ].character = LineA[ i ];

  regs.h.ah = 3;                //  Figure Out where the Original
  regs.h.bh = 0;                //   Cursor Position Is
  int86( VIDINT, &regs, &regs );
  OldRow = regs.h.dh;           //  And Save It
  OldCol = regs.h.dl;

  printf( "Initializing the Mouse\r" );
  InitMouse();                  //  Initialize the Mouse
  printf( "                      \r" );

  regs.h.ah = 1;                //  Turn Off the Cursor
  regs.x.cx = 0x8080;           //  Top Line
  int86( VIDINT, &regs, &regs );

  regs.h.ah = 5;                //  Assume in Mode 3, Jump to a
  regs.h.al = VIDPAGE;          //   New Page for the Simulator
  int86( VIDINT, &regs, &regs );

}  //  End Init

Release()                       //  Restore the Display to Page 0
{

union REGS regs;


  OffMouse();                   //  Turn Off the Mouse

  regs.h.ah = 2;                //  Move the Cursor back to the
  regs.h.bh = 0;                //   Original Location
  regs.h.dh = OldRow;
  regs.h.dl = OldCol;
  int86( VIDINT, &regs, &regs );

  regs.h.ah = 1;                //  Turn On the Cursor
  regs.h.ch = 6;                //  Top Line
  regs.h.cl = 7;                //  Bottom Line
  int86( VIDINT, &regs, &regs );

  regs.h.ah = 5;                //  Restore the Screen to Original
  regs.h.al = 0;                //   Value
  int86( VIDINT, &regs, &regs );

}  //  End Release


Execute()                       //  Execute the Program
{

int   flag = 0;                 //  Set When Ending Program
int   runflag = 0;              //  Set if the Program is Running

int   hour = -1;                //  Create the Time Values
int   minute, second;           //  Delay Values to Write
int   lastsecond;
int   lasthundredth;

union REGS regs;


  while ( flag == 0 ) {         //  Now, Execute the Program

    if ( runflag != 0 )         //  Execute the Program?
      if ( hour == -1 ) {       //  Is the Program Running?
        regs.h.ah = 0x02C;
        intdos( &regs, &regs ); //  Get the Current Time
        lastsecond = regs.h.dh;
        lasthundredth = ExecSpeed;  //  Keep Track of How Many to do
        hour = minute = second = 0;
        PutDelay( hour, minute, second );
        PutIterations( CurIterate = 0 );
      } else {                  //  Else Program is Running, Update?
        regs.h.ah = 0x02C;      //  Get the Latest Time
        intdos( &regs, &regs );
        if ( lastsecond != regs.h.dh ) {
          if ( ++second > 59 ) {  //  Update Execution Time
            second = 0;
            if ( ++minute > 59 ) {
              minute = 0;
              if ( ++ hour > 23 )
                hour = 0;
            }
          }
          PutDelay( hour, minute, second );
          lasthundredth = ExecSpeed;  //  Start Executing Again
          lastsecond = regs.h.dh;     //  Get the New Time
        }  //  endif
        if ( lasthundredth != 0 ) {  //  Execute Another Iteration
          lasthundredth--;      //  Decrement the Counter
          PutIterations( ++CurIterate );
          Play();               //  Play One Iteration
        }  /*  endif  */
      }  /*  endif  */

    regs.x.ax = MOUSEGET;       //  Get the Mouse Status
    int86( MOUSEINT, &regs, &regs );
    if (( regs.x.bx & 1 ) != 0 )  {
      regs.x.cx = regs.x.cx / 8;  //  First Make Into Row/Column
      regs.x.dx = regs.x.dx / 8;
      if ( regs.x.cx < 60 )     //  Put on a Smily Face
        if ( runflag == 0 )     //   - ONLY when Not Running
          Screen[( regs.x.dx * 80 ) + regs.x.cx ].character =
            Screen[( regs.x.dx * 80 ) + regs.x.cx ].character ^ 0x002;
        else
          printf( "%c", 7 );
      else                      //  Handle Go, Stop, End
        if ( regs.x.cx == 62 )  //  Each on Column 62
          switch ( regs.x.dx )
            {
              case 2:           //  Go
                if ( runflag != 0 )
                  printf( "%c", 7 );
                else
                  runflag = 1;
                break;
              case 3:           //  Stop
                if ( runflag == 0 )
                  printf( "%c", 7 );
                else  {         //  Stop and Mark the Program
                  hour = -1;
                  runflag = 0;
                }  //  endif
                break;
              case 4:           //  End
                flag = 1;
                break;
              default:;         //  Ignore Other Locations
            } /*  endswitch  */
        else
          if (( regs.x.cx == 72 ) && ( regs.x.dx == 3 ))
            if ( runflag != 0 )
              printf( "%c", 7 );
            else
              ClearScrn();
      regs.x.ax = MOUSEGET;     //  Wait for the Button to be Released
      int86( MOUSEINT, &regs, &regs );
      while (( regs.x.bx & 1 ) != 0 ) {
        regs.x.ax = MOUSEGET;
        int86( MOUSEINT, &regs, &regs );
      }  /*  endwhile  */
    }  //  endif

    if ( GETKEYSTAT())          //  Is there a Key Available?
      switch ( GETKEY() & 0x0FF )  //  Process Keystrokes
        {
          case 'E':             //  End the Program?
          case 'e':             //  End the Program?
            flag = 1;
            break;
          case 'G':             //  Run the Program?
          case 'g':
            if ( runflag != 0 )
              printf( "%c", 7 );  //  Already Running, "Beep"
            else
              runflag = 1;
            break;
          case 'S':             //  Stop the Program?
          case 's':
            if ( runflag != 0 ) {
              hour = -1;
              runflag = 0;      //  Stop the Program Running
            } else
              printf( "%c", 7 );
            break;
          case 'C':             //  Clear the Screen?
          case 'c':
            if ( runflag != 0 )
              printf( "%c", 7 );
            else
              ClearScrn();
            break;
          case '1':             //  Set the Speed.
            PutSpeed( 1 );
            break;
          case '2':
            PutSpeed( 2 );
            break;
          case '3':
            PutSpeed( 3 );
            break;
          case '4':
            PutSpeed( 4 );
            break;
          case '5':
            PutSpeed( 5 );
            break;
          case '6':
            PutSpeed( 6 );
            break;
          case '7':
            PutSpeed( 7 );
            break;
          case '8':
            PutSpeed( 8 );
            break;
          case '9':
            PutSpeed( 9 );
            break;
          default:;             //  Ignore Everything Else
            printf( "%c", 7 );  //  But, Beep
        } /*  endswitch  */
  }  //  endwhile


}  //  End Execute


//  Mainline
main(argc, argv, envp)
  int argc;
  char *argv[];
  char *envp;
{


  printf( "Game of Life, Version %s\n", ver );
  printf( "Myke Predko\n" );

  Init();                       //  Initialize the Display

  Execute();                    //  Execute the Program

  Release();                    //  Release the Display

}  //  end LIFE
