//  BootTest - Read what is in Sector 1, Track 0, Side 0
//
//  This Program Reads and Displays what is in Sector 1, Track 0,
//   Side 0 of a Diskette and Displays the 512 Bytes of the Sector.
//
//  Myke Predko
//  98.11.17
//

// Defines
#include <stdio.h>
#include <dos.h>
#include <asmprocs.h>

#define DiskInt 0x013           //  Diskette Interrupt
#define DiskReset   0           //  Reset the Drive Subsystem
#define DiskStatus  1           //  Get Status of Previous Operation
#define DiskRead    2           //  Read the Sectors in Memory


//  Global Variables
char Buffer[ 512 ];             //  Data Buffer

//  Subroutines


//  Mainline
main(argc, argv, envp)
  int argc;
  char *argv[];
  char *envp;
{

struct SREGS sregs;
union REGS regs;

int  i, j;


  regs.h.ah = DiskReset;        //  Reset Disk Drive A
  regs.h.dl = 0;
  int86( DiskInt, &regs, &regs );

  regs.h.ah = DiskRead;         //  Read the First Sector
  regs.h.dl = 0;                //   of Disk A
  regs.h.dh = 0;                //  Head 0
  regs.h.ch = 0;                //  Track 0
  regs.h.cl = 1;                //  Sector 1
  regs.h.al = 1;                //  Only 1 Sector
  regs.x.bx = GETOFF( &Buffer[ 0 ]);
  sregs.es = GETSEG( &Buffer[ 0 ]);
  int86x( DiskInt, &regs, &regs, &sregs );

  printf( "Offset      0 1 2 3 4 5 6 7  8 9 A B C D E F  0 1 2 3 4 5 6 7  8 9 A B C D E F\n" );
  for ( i = 0; i < 16; i++ ) {  //  Display What was Read
    printf( "     %3X   ", i * 32 );
    for ( j = 0; j < 32; j++ ) {  //  Display Each Line
      printf( "%2X", Buffer[( i * 32 ) + j ] & 0x0FF );
      if (( j & 0x007 ) == 7 )
        printf( " " );
    }  //  endfor
    printf( "\n" );
  }  //  endfor

}  //  End BootTest
