PAGE ,132                               ;  - Put Printer in 132 Character Mode
TITLE Boot1.ASM - Simple Boot Sector for Testing Diskless Boot
;
;       This Program is a simple boot sector which is going to be loaded into
;       The Boot Sector of a Diskette.  This code is converted into a
;       Binary File.
;
;       Myke Predko
;       Started: 98.11.17
;
PAGE
;
;       CONVENTIONS
;
;       CAPITALS  - CONSTANTS, ASSEMBLER KEYWORDS
;       MixedCase - Variables, Procedure Names, Macros, Structures
;       lowercase - assembler mnemonics
;
;
;       CHAPTERS
;
;       Chapter  1 - Program Information
;       Chapter  2 - Publics and Externals
;       Chapter  3 - Program Segment Information
;       Chapter  4 - Constants
;       Chapter  5 - Structures
;       Chapter  6 - Macros
;       Chapter  7 - Mainline
;       Chapter  8 - Variables
;


PAGE+
;  Define Publics for Subroutines in the Member


PAGE+
ALLPROCS SEGMENT                ;  Segment for Everything
        ASSUME  CS:ALLPROCS, DS:ALLPROCS, ES:ALLPROCS, SS:ALLPROCS


PAGE+
;  Constants
VIDINT  EQU     010h            ;  BIOS Video Interrupt
READCURS EQU    003h            ;  Read the Cursor Position
MOVECURS EQU    002h            ;  Set the Cursor Position
VIDWRITE EQU    009h            ;  Write Attribute/Byte at Cursor


PAGE+
;  Structures
PtrFmt  STRUC                   ;  Pointer Structure Format
PtrOff  dw      ?               ;  Offset
PtrSeg  dw      ?               ;  Segment
PtrFmt  ENDS


PAGE+
;  Macros


PAGE+
;  _GETKEY - Return the First Character in the Keyboard Buffer
 org 0                          ;  Start at Address 0
START:
  mov   AH, VIDWRITE            ;  Write a Character
  mov   AL, 'A'
  mov   BH, 0                   ;  Page 0
  mov   BL, 7                   ;  Grey on Black
  mov   CX, 1                   ;  1 Character
  int   VIDINT

Endless:                        ;  End and Just Loop
  jmp   SHORT Endless

ALLPROCS ENDS
        END     START