PAGE ,132                               ;  - Put Printer in 132 Character Mode
TITLE DongApp.ASM - Dongle Read Application
;
;       This .COM application Is a Simple Program that Indicates
;        That the Dongle Code can Correctly Decod and Reload
;        Applications.
;
;       Myke Predko
;       Started: 98.12.14
;
PAGE
;
;       CONVENTIONS
;
;       CAPITALS  - CONSTANTS, ASSEMBLER KEYWORDS
;       MixedCase - Variables, Procedure Names, Macros, Structures
;       lowercase - assembler mnemonics
;
;
;       CHAPTERS
;
;       Chapter  1 - Program Information
;       Chapter  2 - Publics and Externals
;       Chapter  3 - Program Segment Information
;       Chapter  4 - Constants
;       Chapter  5 - Structures
;       Chapter  6 - Macros
;       Chapter  7 - Mainline
;       Chapter  8 - Subroutines
;       Chapter  9 - Variables
;


PAGE+
;  Define Publics for Subroutines in the Member


PAGE+
ALLPROCS SEGMENT                ;  Segment for Everything
        ASSUME  CS:ALLPROCS, DS:ALLPROCS, ES:ALLPROCS, SS:ALLPROCS


PAGE+
;  Constants
DOSINT  EQU     021h            ;  MS-DOS API Interrupt
DOSSTRG EQU     009h            ;  DOS String Write
DOSEND  EQU     04Ch            ;  End Program

CR      EQU     00Dh            ;  Carriage Return
LF      EQU     00Ah            ;  Line Feed


PAGE+
;  Structures
PtrFmt  STRUC                   ;  Pointer Structure Format
PtrOff  dw      ?               ;  Offset
PtrSeg  dw      ?               ;  Segment
PtrFmt  ENDS


PAGE+
;  Macros


PAGE+
;  Dongle1 - Setup the Correct Variables and Reset the Parallel Port
 org 0100h                      ;  Start at Address 0100h for .COM
START:

  mov   AH, DOSSTRG             ;  Print a Message on the Display
  lea   DX, Msg1
  int   DOSINT

  mov   AH, DOSEND              ;  Return to Command.com
  xor   AL, AL
  int   DOSINT


PAGE+
;  Subroutines


PAGE+
;  Variables
Msg1    db "Dongle Decoded Me Correctly", CR, LF, '$'

ALLPROCS ENDS
        END     START
