//  DongMkr - Put "dongle2.com" Into File with Specified .com File
//
//  This Program Loads the Specified binary file and Merges it with
//   the "dongle2.com" file.  During Execution, the Code will be
//   Moved to address 0x0100 (as it should) if the Dongle is Present.
//
//  This Code was Taken from "BootMkr2".
//
//  Myke Predko
//  98.12.14
//

// Defines
#include <stdio.h>
#include <dos.h>
#include <asmprocs.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>

//  Global Variables
char far * Buffer;              //   For "load" and Application


//  Subroutines


//  Mainline
main(argc, argv, envp)
  int argc;
  char *argv[];
  char *envp;
{

struct SREGS sregs;             //  BIOS Variables
union REGS regs;

int  i;
long j;

int  handle, dongle_handle;     //  File Handling Variables
long handle_size, dongle_size;

char CompString[ 8 ];           //  String to Compare File Data
long Dongle_Break;              //  Location Where the Code was Put

char Encrypt[ 4 ];              //  Encryption String


  printf( "DongMkr\n" );
  printf( "Create an Encrypted .com file that needs the \"Dongle\" on LPT2 to Execute\n\n" );
  printf( "Myke Predko\n" );

  if ( argc != 2 )
    printf( "No Application to Load with the Dongle Code\n" );
  else {                        //  Put Argument and "Dongle2.com" Together

    Buffer = GETMEM( 0x010000L );  //  Get Memory to Load Application

    dongle_handle = open( "dongle2.com", O_RDONLY | O_BINARY );
    dongle_size = lseek( dongle_handle, 0L, SEEK_END );
    lseek( dongle_handle, 0L, SEEK_SET );
    read( dongle_handle, Buffer, handle_size & 0x0FFFF );
    CompString[ 0 ] = 1;        //  Set up the Comparison String
    CompString[ 1 ] = 2;
    CompString[ 2 ] = 3;
    CompString[ 3 ] = 4;
    CompString[ 4 ] = 5;
    CompString[ 5 ] = 6;
    CompString[ 6 ] = 7;
    CompString[ 7 ] = 8;

    for ( i = 0; ( i < ( dongle_size - 8 )) &&
               ( strncmp( &Buffer[ i ], CompString, 8 ) != 0 ); i++ );

    if ( i == ( dongle_size - 8 )) {
      close( dongle_handle );
      printf( "Unable to Find Location to Load the Application Code in \"Dongle2.com\"\n" );
    } else                      //  Load the Application Code
      if (( handle = open( argv[ 1 ], O_RDWR | O_BINARY )) == -1 ) {
        close( dongle_handle );
        printf( "Unable to Find File \"%s\"\n", argv[ 1 ]);
      } else                    //  Read/Load the File - Leave Open

        if (( handle_size = lseek( handle, 0L, SEEK_END )) >
                                              ( dongle_size + 256 )) {
          close( dongle_handle );
          close( handle );
          printf( "File \"%s\" is Too Large to Load\n", argv[ 1 ]);
        } else {                //  Load the File

          Dongle_Break = i;     //  Save the Size of the Dongle2 Start

          Buffer[ i - 2 ] = ( handle_size + Dongle_Break ) & 0x0FF;
          Buffer[ i - 1 ] = ( handle_size + Dongle_Break + 256 ) >> 8;

          Buffer[ i - 4 ] = handle_size & 0x0FF;
          Buffer[ i - 3 ] = handle_size >> 8;

          lseek( handle, 0L, SEEK_SET );
          read( handle, &Buffer[ Dongle_Break ],
                         MINIMUML( 0x07FFFL, handle_size & 0x0FFFF ));
          if ( handle_size > 0x07FFFL )
            read( handle, &Buffer[ Dongle_Break + 0x07FFF ],
                                              handle_size - 0x07FFF );

//  Encode the Application Code

          Encrypt[ 0 ] = 0x012;  //  Initialize the Encrypt String
          Encrypt[ 1 ] = 0x034;
          Encrypt[ 2 ] = 0x056;
          Encrypt[ 3 ] = 0x078;

          for ( i = 0; i < handle_size; i++ )
            Buffer[ Dongle_Break + i ] = Buffer[ Dongle_Break + i ]
                                                   ^ Encrypt[ i & 3 ];

          lseek( dongle_handle, Dongle_Break + 16, SEEK_SET );
          read( dongle_handle, &Buffer[ Dongle_Break + handle_size ],
                                ( dongle_size - Dongle_Break ) - 16 );

          lseek( handle, 0L, SEEK_SET );
          write( handle, Buffer, dongle_size + handle_size );

          close( dongle_handle );  //  Code All Written
          close( handle );

        }  //  endif
  }  //  endif

}  //  End BootMkr2
