PAGE ,132                               ;  - Put Printer in 132 Character Mode
TITLE ExecTest.ASM - Test Out the Boot Loader File From Diskette
;
;       This Program is a Program that loads the first sector on the
;       Diskette and then start executing at it's first address to see how
;       it runs.  This is a .COM File.
;
;       Myke Predko
;       Started: 98.11.18
;
PAGE
;
;       CONVENTIONS
;
;       CAPITALS  - CONSTANTS, ASSEMBLER KEYWORDS
;       MixedCase - Variables, Procedure Names, Macros, Structures
;       lowercase - assembler mnemonics
;
;
;       CHAPTERS
;
;       Chapter  1 - Program Information
;       Chapter  2 - Publics and Externals
;       Chapter  3 - Program Segment Information
;       Chapter  4 - Constants
;       Chapter  5 - Structures
;       Chapter  6 - Macros
;       Chapter  7 - Mainline
;       Chapter  8 - Subroutines
;       Chapter  9 - Variables
;


PAGE+
;  Define Publics for Subroutines in the Member


PAGE+
ALLPROCS SEGMENT                ;  Segment for Everything
        ASSUME  CS:ALLPROCS, DS:ALLPROCS, ES:ALLPROCS, SS:ALLPROCS


PAGE+
;  Constants
DISKINT  EQU    013h            ;  Diskette Interrupt
DISKRST  EQU    000h            ;  Reset Disk Sub-System
DISKREAD EQU    002h            ;  Read the Diskette

VIDINT   EQU    010h            ;  BIOS Video Interrupt
READCURS EQU    003h            ;  Read the Cursor Position
MOVECURS EQU    002h            ;  Set the Cursor Position
VIDWRITE EQU    009h            ;  Write Attribute/Byte at Cursor


PAGE+
;  Structures
PtrFmt  STRUC                   ;  Pointer Structure Format
PtrOff  dw      ?               ;  Offset
PtrSeg  dw      ?               ;  Segment
PtrFmt  ENDS


PAGE+
;  Macros


PAGE+
;  _GETKEY - Return the First Character in the Keyboard Buffer
 org 0100h                      ;  Start at Address 0100h for .COM
START:

  mov   AH, DISKRST             ;  Reset the Disk Sub-System
  mov   DL, 0
  int   DISKINT

  mov   AH, DISKREAD            ;  READ the Application from the Diskette
  mov   DL, 0
  mov   DH, 0                   ;  Head 0
  mov   CH, 0                   ;  Track 0
  mov   CL, 1                   ;  Sector 1 (Boot Sector)
  mov   AL, 1                   ;  Read in First 8,7104 Bytes
  mov   BX, 0200h               ;  Point Past Currently Loaded Code
  int   DISKINT

  jmp   TestStart

 org 0200h
TestStart:


PAGE+
;  Variables

ALLPROCS ENDS
        END     START