PAGE ,132                               ;  - Put Printer in 132 Character Mode
TITLE TestApp.ASM - Test Application
;
;       This .COM application Simply Writes the Message "Working..."
;       on the Display.  It is meant to be loaded from a Boot Disk.
;
;       Myke Predko
;       Started: 98.11.17
;
PAGE
;
;       CONVENTIONS
;
;       CAPITALS  - CONSTANTS, ASSEMBLER KEYWORDS
;       MixedCase - Variables, Procedure Names, Macros, Structures
;       lowercase - assembler mnemonics
;
;
;       CHAPTERS
;
;       Chapter  1 - Program Information
;       Chapter  2 - Publics and Externals
;       Chapter  3 - Program Segment Information
;       Chapter  4 - Constants
;       Chapter  5 - Structures
;       Chapter  6 - Macros
;       Chapter  7 - Mainline
;       Chapter  8 - Subroutines
;       Chapter  9 - Variables
;


PAGE+
;  Define Publics for Subroutines in the Member


PAGE+
ALLPROCS SEGMENT                ;  Segment for Everything
        ASSUME  CS:ALLPROCS, DS:ALLPROCS, ES:ALLPROCS, SS:ALLPROCS


PAGE+
;  Constants
VIDINT  EQU     010h            ;  BIOS Video Interrupt
READCURS EQU    003h            ;  Read the Cursor Position
MOVECURS EQU    002h            ;  Set the Cursor Position
VIDWRITE EQU    009h            ;  Write Attribute/Byte at Cursor


PAGE+
;  Structures
PtrFmt  STRUC                   ;  Pointer Structure Format
PtrOff  dw      ?               ;  Offset
PtrSeg  dw      ?               ;  Segment
PtrFmt  ENDS


PAGE+
;  Macros


PAGE+
;  TestApp - Return the First Character in the Keyboard Buffer
 org 0100h                      ;  Start at Address 0100h for .COM
START:

  mov   AH, MOVECURS            ;  Move Cursor to Screen Top
  mov   BH, 0
  xor   DX, DX
  int   VIDINT

  call  GetAddr
  add   SI, Msg - $             ;  Display the Message
  call  MsgDisplay

Endless:                        ;  End and Just Loop
  jmp   SHORT Endless


PAGE+
;  Subroutines
GetAddr:                        ;  Get the Address of the Call

  pop   SI

  push  SI

  ret

MsgDisplay:                     ;  Display to the Zero

  mov   AL, CS:[SI]
  cmp   AL, 0                   ;  At the End of the String?
  jz    MD_End
  mov   AH, VIDWRITE
  mov   BH, 0
  mov   BL, 7
  mov   CX, 1
  int   VIDINT

  call  CursIncrement

  inc   SI                      ;  Point to the Next Character

  jmp   MsgDisplay

MD_End:                         ;  At the End of the String

  ret

CursIncrement:                  ;  Increment the Current Cursor Postion

  mov   AH, READCURS            ;  Increment the Cursor Position
  mov   BH, 0
  int   VIDINT
  mov   AH, MOVECURS
  inc   DL
  int   VIDINT

  ret


PAGE+
;  Variables
Msg     db "Working...", 0

ALLPROCS ENDS
        END     START
