//  SBSCREEN.C - Show how the Soundblaster can Affect the Screen
//
//  Using the funky sound of "sbtest2", Blank out a Screen.
//
//  Myke Predko
//  99.02.15
//

//  Defines
#include <stdio.h>
#include <asmprocs.h>


//  Global Variables
char Screen[ 25 * 80 ];         //  Save the Original Screen
char far * ScreenPtr;           //  Video Buffer


//  Subroutines
SBWrite( int Addr, int Value )  //  Write the Value to the SB Card
{

int  i;

  outp( 0x0220, Addr );         //  Write the Address to the SB Port
  for ( i = 0; i < 6; i++ )     //   Delay 3.3 usecs for Operation
    inp( 0x0220 );              //   to complete

  outp( 0x0221, Value );        //  Output the Value and Wait 23 usecs
  for ( i = 0; i < 84; i++ )    //   for the Operation to Complete
    inp( 0x0220 );

}  //  End SBWrite

TimeDelay()                     //  One Clock "Tick"
{

long far * CurTime;             //  Pointer to the PC's Time Function
long i;


  (long) CurTime = 0x00040006CL;

  i = *CurTime;
  while ( i == *CurTime );      //  Wait for the End of the Interval

}  //  End TimeDelay


//  Mainline
main(argc, argv, envp)          //  Output a Simple Sound
  int argc;
  char *argv[];
  char *envp;
{

int i, j;


  (long) ScreenPtr = 0x0B8000000L;
  for ( i = 0; i < 25; i++ )
    for ( j = 0; j < 80; j++ )
      Screen[( i * 80 ) + j ] = ScreenPtr[( i * 160 ) + ( j * 2 )];

  SBWrite( 0x020, 0x001 );
  SBWrite( 0x040, 0x010 );
  SBWrite( 0x060, 0x01F );
  SBWrite( 0x080, 0x00F );
  SBWrite( 0x0A0, 0x0AE );
  SBWrite( 0x023, 0x001 );
  SBWrite( 0x043, 0x000 );
  SBWrite( 0x063, 0x0F0 );
  SBWrite( 0x083, 0x077 );
  SBWrite( 0x0B0, 0x032 );

  for ( i = 0; i < 25; i++ ) {  //  Clear All 25 Lines
    for ( j = 0; j < 80; j++ )
      ScreenPtr[( i * 160 ) + ( j * 2 )] = ' ';
    TimeDelay();                //  Put in a 1/18 sec Time Delay
  }

  SBWrite( 0x080, 0x00F );      //  Put in a Fast Decay
  SBWrite( 0x083, 0x00F );
  SBWrite( 0x0B0, 0x011 );

  while ( GETKEYSTAT() != 0 )   //  Wait for Keystroke to Replace
    GETKEY();
  GETKEY();

  for ( i = 0; i < 25; i++ )    //  Restore the Display
    for ( j = 0; j < 80; j++ )
      ScreenPtr[( i * 160 ) + ( j * 2 )] = Screen[( i * 80 ) + j ];

}  //  End main
