//  SBTEST2.C - Test the SoundBlaster Interface
//
//  This Code is used to demonstrate SoundBlaster Register Reading
//   and writing to produce a specified sound.  This application is
//   written in "C" to allow multiple sounds be selected.
//
//  In this Program, a Sound Effect is Generated.
//
//  Myke Predko
//  99.02.15
//

//  Defines
#include <stdio.h>


//  Global Variables


//  Subroutines
SBWrite( int Addr, int Value )  //  Write the Value to the SB Card
{

int  i;

  outp( 0x0220, Addr );         //  Write the Address to the SB Port
  for ( i = 0; i < 6; i++ )     //   Delay 3.3 usecs for Operation
    inp( 0x0220 );              //   to complete

  outp( 0x0221, Value );        //  Output the Value and Wait 23 usecs
  for ( i = 0; i < 84; i++ )    //   for the Operation to Complete
    inp( 0x0220 );

}  //  End SBWrite

TimeDelay( int Delay )          //  Delay the Specified Number of
{                               //   Half Seconds

long far * CurTime;             //  Pointer to the PC's Time Function
long i;
int  j, k;


  (long) CurTime = 0x00040006C;

  for ( j = 0; j < Delay; j++ )
    for ( k = 0; k < 9; k++ ) {  //  Delay a 1/2 Second
      i = *CurTime;
      while ( i == *CurTime );
    }

}  //  End TimeDelay


//  Mainline
main(argc, argv, envp)          //  Output a Simple Sound
  int argc;
  char *argv[];
  char *envp;
{


  SBWrite( 0x020, 0x001 );
  SBWrite( 0x040, 0x010 );
  SBWrite( 0x060, 0x01F );
  SBWrite( 0x080, 0x00F );
  SBWrite( 0x0A0, 0x0AE );
  SBWrite( 0x023, 0x001 );
  SBWrite( 0x043, 0x000 );
  SBWrite( 0x063, 0x0F0 );
  SBWrite( 0x083, 0x077 );
  SBWrite( 0x0B0, 0x032 );

  TimeDelay( 4 );               //  Wait two Seconds

  SBWrite( 0x080, 0x00F );      //  Put in a Fast Decay
  SBWrite( 0x083, 0x00F );
  SBWrite( 0x0B0, 0x011 );

}  //  End main
