//  Delay_C - Pulse the LPT2 "_STROBE" Line for 10 usecs
//
//  This Application Pulses LPT2's "_STROBE" line Low for
//   10 usecs using the "DELAY" Assembler Code.  This
//   Function Repeats until a Key is pressed
//
//  Myke Predko
//  98.11.24
//


//  Defines
#include <stdio.h>
#include <conio.h>
#include <asmprocs.h>


//  Constants
#define LPT2 0x0278             //  I/O Address of LPT2


//  Subroutines
int DLAY( int Delay );          //  Subroutine to Delay the Output
                                //   to a Constant Time.


//  Mainline
main(argc, argv, envp)
  int argc;
  char *argv[];
  char *envp;
{

int  Temp;


  printf( "Outputting a Constant Stream of 10 usecs Negative Pulses on LPT2\'s \"_STROBE\"\n\n" );
  printf( "Press Any Key to Stop the Program\n" );

  while ( GETKEYSTAT() != 0 )   //  Clear the Keyboard Buffer
    GETKEY();

  while ( GETKEYSTAT() == 0 ) { //  Wait for a Keystroke

    CLI();                      //  Disable Interrupts

    outp( LPT2 + 2, ( Temp = inp( LPT2 + 2 )) ^ 1 );

    DLAY( 10 );                 //  Delay 10 usecs

    outp( LPT2 + 2, Temp );

    STI();                      //  Turn Interrupts Back On

  }  /*  endwhile  */
  GETKEY();                     //  Clear the Key from the Buffer

}  //  End Mainline
